

#include <X11/XKBlib.h>
#include <stdio.h>
#include "leds.h"
#include "aquarium.h"
#include "draw.h"

static SA_Image *led_images=NULL;
static Leds_settings leds_settings;
static AquariumData *ad;

Leds_settings *leds_get_settings_ptr(void)
{
    return &leds_settings;
}

/*
  Returns the turned on leds:
  Bit 0 is Capslock
  Bit 1 is Numlock
  Bit 2 is Scrollock
*/

/*
  This code is based upon some lines(actually two lines :-) 
  in E-Leds by Mathias Meisfjordskar<mathiasm@ifi.uio.no>
  Released under GPL.
*/

static int check_kleds(void)
{
    static Display *display;
    AquariumData *ad;
    unsigned int states;
    
    ad = aquarium_get_settings_ptr();

    if(display==NULL) display=XOpenDisplay(NULL);

    if (XkbGetIndicatorState(display, XkbUseCoreKbd, &states) != Success) {
	perror("Error while reading Indicator status\n");
	return -1;
    }
    return (states & 0x7);
}

static int get_capslock(void)
{
    if((check_kleds()&1)==1) return 1;
    else return 0;
}

static int get_numlock(void)
{
    if((check_kleds()&2)==2) return 1;
    else return 0;
}
static int get_scrollock(void)
{
    if((check_kleds()&4)==4) return 1;
    else return 0;
}


static void do_led(int on, int type, int colour, int show_off, int x, int y, int beforeorafter)
{
    int is_on;

    if(!on) return;
    /*
    switch(type){
    case CAPSLOCK:
	is_on=get_capslock();
	break;
    case NUMLOCK:
	is_on=get_numlock();
	break;
    case SCROLLOCK:
	is_on=get_scrollock();
	break;
    default:
	is_on=0;
	break;
    }

    
    
    if((!is_on && show_off && leds_settings.when_update_show_off==beforeorafter) || 
       (is_on && leds_settings.when_update==beforeorafter))
	draw_pic_alpha(led_images[colour].image,
		       led_images[colour].width,
		       led_images[colour].height,
		       x,y,!is_on,80);
    */

}

void leds_exit(void)
{
    /*    int i;
    if(led_images==NULL) return;

    for(i=0;i<NUM_LED_IMAGES;i++){
	if(led_images[i].image!=NULL)
	    g_object_unref(led_images[i].pixbuf);
    }

    g_free(led_images);
    led_images=NULL;

    */

}

void leds_init(void)
{
    /*    int i;
    char *led_files[] = {
    "leds/blue.png",
    "leds/bluegreen.png",
    "leds/orange.png",
    "leds/red.png",
    "leds/violet.png",
    "leds/yellow.png",
    "leds/pink.png",
    "leds/green.png",
    "leds/darkblue.png",
    "leds/lightblue.png",
    "leds/yellowgreen.png",
    NULL};

    ad = aquarium_get_settings_ptr();

    if(ad->full_screen)
	return;

    if(led_images!=NULL)
	leds_exit();

    led_images = g_malloc0(sizeof(SA_Image)*NUM_LED_IMAGES);

    for(i=0;;i++){
	if(led_files[i]==NULL) break;
	load_image(led_files[i],
		   &led_images[i],2);

    }
    */

}





void leds_update(int beforeorafter)
{
    /*    int numleds=0;
    int x,y,i;

    if(ad->full_screen)
	return;

    if(beforeorafter!=leds_settings.when_update && 
       beforeorafter!=leds_settings.when_update_show_off)
	return;

    if(!leds_settings.on)
	return;


    for(i=0;i<3;i++)
	numleds+=leds_settings.led_on[i];


    switch(leds_settings.placement_h){
    case LEDS_LEFT:
	x=2;
    case LEDS_RIGHT:
	x=ad->xmax-numleds*led_images[0].width-2;
    case LEDS_CENTER:
	x=(ad->xmax-numleds*led_images[0].width)/2;
    default:
	x=2;
    }

    switch(leds_settings.placement_v){
    case LEDS_TOP:
	y=2;
    case LEDS_BOTTOM:
	y=ad->ymax-numleds*led_images[0].height-2;
    case LEDS_CENTER:
	y=(ad->ymax-numleds*led_images[0].height)/2;
    default:
	y=2;

	
    }

    for(i=0;i<numleds;i++)
	do_led(leds_settings.led_on[i],
	       leds_settings.led_type[i], 
	       leds_settings.led_colour[i],
	       leds_settings.led_show_off_led[i], 
	       x + !leds_settings.vertical*led_images[0].width*i, 
	       y + leds_settings.vertical*led_images[0].height*i, beforeorafter);

    */

}
